﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace EduNetworkBuilder
{
    public class PersonClass
    {
        public string filepath=""; //the path of the file.  We use the username as the file-name.

        string _UserName="";
        /// <summary>
        /// The username of the person.  Will be used as a filename.  Cannot be changed once it is set
        /// </summary>
        public string UserName { get { return _UserName; } }

        /// <summary>
        /// The full name of the person. Can have spaces and punctuation.  Can change as one wants it changed.
        /// </summary>
        public string FullName = "";  

        List<string> Passwords = new List<string>();

        string PasswordHint = "";
        /// <summary>
        /// The AltPassword is mainly used to hold the admin decrypting password.  The student account will
        /// use this to encrypt the student password, so the admin can open their file.
        /// </summary>
        string AltPassword = "";
        /// <summary>
        /// Used to determine if the user we are working with is the admin account.
        /// </summary>
        public bool isAdmin { get; private set; }
        /// <summary>
        /// EverCompletedPuzzles is a list of puzzles that they have completed once.
        /// </summary>
        List<string> EverCompletedPuzzles = new List<string>();

        List<SchoolworkClass> Projects = new List<SchoolworkClass>();

        public PersonClass(String User, bool MakeAdmin)
        {
            _UserName = User;
            isAdmin = MakeAdmin;
        }

        public string Password(int index = 0)
        {
            if (Passwords.Count == 0) return "";
            if (index < 0) return "";
            if (index >= Passwords.Count) return "";
            return Passwords[index];
        }

        public void ChangePassword(string NewPassword)
        {
            Passwords.Insert(0, NewPassword);
            int maxPWs = 1;
            if (isAdmin)
                maxPWs = 10; //Admins store the last 10 passwords. If the admin changed his PW, we still need to decrypt the student's files
            for (int a = Passwords.Count - 1; a >= maxPWs; a--)
                Passwords.RemoveAt(a); //Remove all but the one password
        }
    }
}
